5d2771c238
- mkinitrd-suse.sh: Bail out with exit 1 if initrd cannot be generated (bnc#886630) * Add: 0120-mkinitrd-suse.sh-Bail-out-with-exit-1-if-initrd-cann.patch - Adjust initramfs-$kernel.img to SUSE default: initrd-$kernel (bnc#882306) * Add: 0121-Adjust-initramfs-kernel.img-to-SUSE-default-initrd-k.patch - btrfs: btrfs-dump-super and btrfs-select-super do not exist (bnc#886883) * Add: 0122-btrfs-btrfs-dump-super-and-btrfs-select-super-do-not.patch - 95zfcp_rules: fix typo in module_setup (bnc#887582) * Add: 0123-95zfcp_rules-fix-typo-in-module_setup.patch - 40network: Update iBFT scanning code to handle IPv6 (bnc#887542) * Add: 0124-40network-Update-iBFT-scanning-code-to-handle-IPv6.patch - 40network: separate 'mask' and 'prefix' (bnc#887542) * Add: 0125-40network-separate-mask-and-prefix.patch - 01fips: Add drbg module to force loaded modules (bnc#875855) * Add: 0126-01fips-Add-drbg-module-to-force-loaded-modules.patch OBS-URL: https://build.opensuse.org/request/show/241711 OBS-URL: https://build.opensuse.org/package/show/Base:System/dracut?expand=0&rev=174
94 lines
3.7 KiB
Diff
94 lines
3.7 KiB
Diff
From de870b8879974927873264010b6294a70b6c7980 Mon Sep 17 00:00:00 2001
|
|
From: Hannes Reinecke <hare@suse.de>
|
|
Date: Thu, 17 Jul 2014 14:09:28 +0200
|
|
Subject: 40network: Update iBFT scanning code to handle IPv6
|
|
|
|
IPv6 addresses should be specified in brackets so that the
|
|
ip= scanning code doesn't get confused.
|
|
|
|
References: bnc#887542
|
|
|
|
Signed-off-by: Hannes Reinecke <hare@suse.de>
|
|
---
|
|
modules.d/40network/net-lib.sh | 48 +++++++++++++++++++++++++++++++++++++-----
|
|
1 file changed, 43 insertions(+), 5 deletions(-)
|
|
|
|
diff --git a/modules.d/40network/net-lib.sh b/modules.d/40network/net-lib.sh
|
|
index a82f1a8..554f723 100755
|
|
--- a/modules.d/40network/net-lib.sh
|
|
+++ b/modules.d/40network/net-lib.sh
|
|
@@ -200,20 +200,51 @@ ibft_to_cmdline() {
|
|
|
|
[ -e /tmp/net.${dev}.has_ibft_config ] && continue
|
|
|
|
+ [ -e ${iface}/flags ] && flags=$(read a < ${iface}/flags; echo $a)
|
|
+ # Skip invalid interfaces
|
|
+ (( $flags & 1 )) || continue
|
|
+ # Skip interfaces not used for booting
|
|
+ (( $flags & 2 )) || continue
|
|
[ -e ${iface}/dhcp ] && dhcp=$(read a < ${iface}/dhcp; echo $a)
|
|
-
|
|
- if [ -n "$dhcp" ]; then
|
|
- echo "ip=$dev:dhcp"
|
|
+ [ -e ${iface}/origin ] && origin=$(read a < ${iface}/origin; echo $a)
|
|
+ [ -e ${iface}/ip-addr ] && ip=$(read a < ${iface}/ip-addr; echo $a)
|
|
+
|
|
+ if [ -n "$ip" ] ; then
|
|
+ case "$ip" in
|
|
+ *.*.*.*)
|
|
+ family=ipv4
|
|
+ ;;
|
|
+ *:*)
|
|
+ family=ipv6
|
|
+ ;;
|
|
+ esac
|
|
+ fi
|
|
+ if [ -n "$dhcp" ] || [ "$origin" -eq 3 ]; then
|
|
+ if [ "$family" = "ipv6" ] ; then
|
|
+ echo "ip=$dev:dhcp6"
|
|
+ else
|
|
+ echo "ip=$dev:dhcp"
|
|
+ fi
|
|
elif [ -e ${iface}/ip-addr ]; then
|
|
- [ -e ${iface}/ip-addr ] && ip=$(read a < ${iface}/ip-addr; echo $a)
|
|
# skip not assigned ip adresses
|
|
[ "$ip" = "0.0.0.0" ] && continue
|
|
[ -e ${iface}/gateway ] && gw=$(read a < ${iface}/gateway; echo $a)
|
|
[ -e ${iface}/subnet-mask ] && mask=$(read a < ${iface}/subnet-mask; echo $a)
|
|
+ [ -e ${iface}/prefix-len ] && prefix=$(read a < ${iface}/prefix-len; echo $a)
|
|
[ -e ${iface}/primary-dns ] && dns1=$(read a < ${iface}/primary-dns; echo $a)
|
|
[ -e ${iface}/secondary-dns ] && dns2=$(read a < ${iface}/secondary-dns; echo $a)
|
|
[ -e ${iface}/hostname ] && hostname=$(read a < ${iface}/hostname; echo $a)
|
|
- if [ -n "$ip" ] && [ -n "$mask" ]; then
|
|
+ if [ "$family" = "ipv6" ] ; then
|
|
+ if [ -n "$ip" ] ; then
|
|
+ [ -n "$prefix" ] || prefix=64
|
|
+ ip="[${ip}/${prefix}]"
|
|
+ mask=
|
|
+ fi
|
|
+ if [ -n "$gw" ] ; then
|
|
+ gw="[${gw}]"
|
|
+ fi
|
|
+ fi
|
|
+ if [ -n "$ip" ] && [ -n "$mask" -o -n "$prefix" ]; then
|
|
echo "ip=$ip::$gw:$mask:$hostname:$dev:none${dns1:+:$dns1}${dns2:+:$dns2}"
|
|
else
|
|
warn "${iface} does not contain a valid iBFT configuration"
|
|
@@ -373,6 +404,13 @@ ip_to_var() {
|
|
esac
|
|
;;
|
|
esac
|
|
+ # Extract prefix length from CIDR notation
|
|
+ case $ip in
|
|
+ */*)
|
|
+ mask=${ip##*/}
|
|
+ ip=${ip%/*}
|
|
+ ;;
|
|
+ esac
|
|
|
|
# ip=<ipv4-address> means anaconda-style static config argument cluster:
|
|
# ip=<ip> gateway=<gw> netmask=<nm> hostname=<host> mtu=<mtu>
|
|
--
|
|
1.8.4.5
|
|
|